﻿package 
{
	import flash.display.MovieClip;
	import AccordionListHeader;
	import AccordionListItem;
	import AccordionHeaderEvent;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	/**
	 * ...
	 * @author Jeroen Oliemans
	 */
	public class AccordionList extends MovieClip
	{
		private var accordionData:Array;
		
		public function AccordionList()
		{
			init();
		}
		
		private function init():void
		{
			
			makeData();
			buildLayout();
			addEventListeners();
		}
		
		private function addEventListeners():void
		{
			addEventListener( AccordionHeaderEvent.HEADER_CLICKED, headerClickHandler );
		}
		
		private function headerClickHandler(e:AccordionHeaderEvent):void 
		{
			setAccordion( e.id );
		}
		
		private function setAccordion( id:Number ):void
		{
			var activeHeader:AccordionListHeader = this.getChildAt( id ) as AccordionListHeader;
			
			// reset all headers
			//var offSetY:Number = accordionData[ id ].length * 20;
			var offSetY:Number = accordionData[ id ].menuItems.length * 20;
			for (var i:int = 0; i < accordionData.length; i++) 
			{
				var resetHeader:AccordionListHeader = this.getChildAt( i ) as AccordionListHeader;
				resetHeader.y = 10 + (i * 25);
				resetHeader.hideItems();
			}
			//offset items below active header
			for (var k:int = id + 1; k < accordionData.length; k++)
			{
				var headersAfterActive:AccordionListHeader = this.getChildAt(k) as AccordionListHeader;
				headersAfterActive.y += offSetY;
			}
			activeHeader.showItems();
		}
		
		private function buildLayout():void
		{
			var nextHeaderY:Number = 0;
			
			for (var i:int = 0; i < accordionData.length; i++) 
			{
				var header:AccordionListHeader = new AccordionListHeader( accordionData[i].menuItems );
				header.x = 10;
				header.id = i;
				header.header_txt.text = accordionData[i].title;
				header.y = 10 + (i * 25) + nextHeaderY;
				addChild( header );		
			}
			// open the first menu
			setAccordion( 0 );
		}
		
		private function makeData():void
		{
			accordionData = new Array();

			accordionData[0] = { title: "header 1",  menuItems: new Array( "item 1", "item 2", "item 3", "item 4"  ) };
			accordionData[1] = { title: "header 2",  menuItems: new Array( "item 1", "item 2", "item 3"  ) };
			accordionData[2] = { title: "header 3",  menuItems: new Array( "item 1"  ) };
			accordionData[3] = { title: "header 4",  menuItems: new Array( "item 1", "item 2", "item 3", "item 4"  ) };
			accordionData[4] = { title: "header 5",  menuItems: new Array( "item 1", "item 2", "item 3", "item 4", "item 5", "item 6", "item 7"  ) };
			accordionData[5] = { title: "header 6",  menuItems: new Array( "item 1", "item 2", "item 3", "item 4", "item 5", "item 6", "laatste"  ) };
		}
	}
	
}